<?php
namespace Teknisa\EST\Modules\EstoqueCego\Controllers;

use Teknisa\EST\Controllers\TeknisaCrud;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Request\Filter;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO;

class Est90000PerfilDeOperadoresDoInventarioCegoController extends TeknisaCrud {

    protected $dataSourceName = "";
    protected $parameterBagColumns = [];

    protected $Service;
    protected $dataSourceManager;
    protected $environment;
    
    public function __construct($crudService,$parameterBag, $Est90000Service,$dataSourceManager,$environment,$entityManager) {
        parent::__construct($crudService,$parameterBag,$environment);

        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
        $this->Service = $Est90000Service;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        
        $conditions = $request->getFilterCriteria()->getConditions();
        
        $this->Est91000ProgramacaoDoInventarioCegoService->formatMutipleFilialCode($conditions);
        
        $newFilterCriteria = new FilterCriteria($this->dataSourceName, $conditions);
        $filter = new DTO\Request\Filter($newFilterCriteria, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
        
        parent::find($filter, $response);
    }
    
    public function onSaveOperation(Request $request, Response $response) {
        try {
            $row = $request->getRow();
            $this->Service->onSaveOperation($row);
            
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
    
    public function onDeleteOperation(Request $request, Response $response) {
        try {
            $row = $request->getRow();
            $this->Service->onDeleteOperation($row);
            
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
}
