<?php
namespace Planejamento\Entities;

use \Geral\Entities\Unidmedida;

class Convproduto extends Base\Convproduto
{

    /**
     * Atualiza Convproduto via doctrine
     *
     * @static
     *
     * @param $cdproduto
     * @param $dtultatu
     * @param $dtultatucnpr
     * @param $nrorg
     * @param $nrorgultatu
     * @param $sgunidade
     * @param $vrfatoconves
     *
     * @return null
     */
    public static function atualizaConvproduto(
        $cdproduto, $dtultatu, $dtultatucnpr, $nrorg,
        $nrorgultatu, $sgunidade, $vrfatoconves
    )
    {
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $connection->beginTransaction();
        /** @var \Planejamento\Entities\Convproduto $obj_Convproduto */
        $obj_Convproduto = \Planejamento\Entities\Convproduto::getObjectByWhere(
            'NRORG = ? AND CDPRODUTO = ? AND SGUNIDADE = ?',
            array($nrorg, $cdproduto, $sgunidade)
        );

        $obj_Convproduto->setDtultatu($dtultatu);
        $obj_Convproduto->setDtultatucnpr($dtultatucnpr);
        $obj_Convproduto->setNrorgultatu($nrorgultatu);
        $obj_Convproduto->setVrfatoconves($vrfatoconves);
        $obj_Convproduto->persist();

        $connection->flush();
        $connection->commit();
    }

    /**
     * Insere Convproduto via doctrine
     *
     * @static
     *
     * @param $cdoperinclusao
     * @param $cdoperultatu
     * @param $cdproduto
     * @param $dtinclusao
     * @param $dtultatu
     * @param $dtultatucnpr
     * @param $idativo
     * @param $nrorg
     * @param $nrorginclusao
     * @param $nrorgultatu
     * @param $sgunidade
     * @param $vrfatoconves
     *
     * @return null
     */
    public static function insereConvproduto(
        $cdoperinclusao, $cdoperultatu, $cdproduto, $dtinclusao,
        $dtultatu, $dtultatucnpr, $nrorg,
        $nrorginclusao, $nrorgultatu, $sgunidade, $vrfatoconves
    )
    {
        /** @var \Geral\Entities\Unidmedida $sgunidadeObj */
        $sgunidadeObj = \Geral\Entities\Unidmedida::getObjectByWhere(
            'NRORG = ? AND SGUNIDADE = ?', array($nrorg, $sgunidade)
        );

        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $connection->beginTransaction();
        /** @var \Planejamento\Entities\Convproduto $obj_Convproduto */
        $obj_Convproduto = new \Planejamento\Entities\Convproduto();

        $obj_Convproduto->setCdoperinclusao($cdoperinclusao);
        $obj_Convproduto->setCdoperultatu($cdoperultatu);
        $obj_Convproduto->setCdproduto($cdproduto);
        $obj_Convproduto->setDtinclusao($dtinclusao);
        $obj_Convproduto->setDtultatu($dtultatu);
        $obj_Convproduto->setDtultatucnpr($dtultatucnpr);
        $obj_Convproduto->setNrorg($nrorg);
        $obj_Convproduto->setNrorginclusao($nrorginclusao);
        $obj_Convproduto->setNrorgultatu($nrorgultatu);
        $obj_Convproduto->setSgunidade($sgunidade);
        $obj_Convproduto->setSgunidadeObj($sgunidadeObj);
        $obj_Convproduto->setVrfatoconves($vrfatoconves);
        $obj_Convproduto->persist();

        $connection->flush();
        $connection->commit();
    }


    /**
     * Exclui conversao para uma unidade de um produto via doctrine
     *
     * @param $row
     *
     * @return null
     */
    public static function excluiConversao($row) {
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $connection->beginTransaction();

        /** @var \Planejamento\Entities\Convproduto $obj_Convproduto */
        $obj_Convproduto = self::getObjectByWhere('NRORG = ? AND CDPRODUTO = ? AND SGUNIDADE = ?',
            array($row['NRORG'], $row['CDPRODUTO'], $row['SGUNIDADE']));

        if (is_object($obj_Convproduto)) {
            $obj_Convproduto->delete();

            $connection->flush();
            $connection->commit();
        }
    }

     /**
     * Exclui conversao para uma unidade de um produto via doctrine
     *
     * @param $row
     *
     * @return null
     */
    public static function excluiConversoesProduto($row) {
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $connection->beginTransaction();

        $array_Convproduto = \Planejamento\Entities\Convproduto::getObjectsByWhere('NRORG = ? AND CDPRODUTO = ?',
            array($row['NRORG'], $row['CDPRODUTO']));

        if (!empty($array_Convproduto)) {
            /** @var \Planejamento\Entities\Convproduto $obj_Convproduto */
            foreach($array_Convproduto as $chave => $obj_Convproduto) {
                if (is_object($obj_Convproduto)) {
                    $obj_Convproduto->delete();
                    $connection->flush();
                }
            }
            $connection->commit();
        }
    }



}