function Est31300_MovimentacaodeEstoque_Controller(restEngine, General, ScreenService, Est31300_MovimentacaodeEstoque_Service, ProductField, templateManager, metaDataFactory, eventEngine) {

    this.checkUnidadeFields = function(widget) {
        var currentRow = widget.currentRow;

        ProductField.updateProductFilters(widget);
        if (currentRow.REPORT_NAME === 'Est31300MovEstoque' ||
            currentRow.REPORT_NAME === 'Est31300MovEstoqueSintetico' ||
            currentRow.REPORT_NAME === 'Est31300MovEstoqueSinteticoQuantidade') {
            if (currentRow.CDFILIAL) {
                Est31300_MovimentacaodeEstoque_Service.requestValidations(currentRow.CDFILIAL).then(function(checks) {
                    currentRow.ALMOXARIFADO = checks.IDUTILALMOX;
                    currentRow.LOCALESTOQUE = checks.IDUTILLCESTQ;
                    currentRow.LOTE = checks.IDUTILLOTE;

                    var almoxarifado = widget.getField('DSALMOXARIFE');
                    var localestoque = widget.getField('DSLOCALESTOQ');
                    var lote = widget.getField('NRLOTEESTQ');

                    if (currentRow.LOTE) {
                        lote.dataSourceFilter[1] = { "name": "CDFILIAL", "operator": "=", "value": currentRow.CDFILIAL };
                        lote.readOnly = false;
                        currentRow.NRLOTEESTOQ = null;

                        this.reloadFields(widget, false, false, true);
                    }
                    else {
                        lote.readOnly = true;
                        lote.setValue('');
                        currentRow.NRLOTEESTOQ = " ";
                        
                    }
                    if (currentRow.ALMOXARIFADO) {
                        almoxarifado.dataSourceFilter[0] = { "name": "CDFILIAL", "operator": "=", "value": currentRow.CDFILIAL };
                        almoxarifado.readOnly = false;
                        almoxarifado.validations = { "required": true };
                        this.reloadFields(widget, true, false, false);

                        if (currentRow.LOCALESTOQUE) {
                            localestoque.dataSourceFilter[0] = { "name": "CDFILIAL", "operator": "=", "value": currentRow.CDFILIAL };
                            localestoque.validations = { "required": true };

                            this.checkAlmoxariFields(widget, true);
                        }
                        else {
                            localestoque.readOnly = true;
                            localestoque.setValue(' ');
                            localestoque.validations = null;
                        }
                    }
                    else {
                        almoxarifado.readOnly = true;
                        almoxarifado.validations = null;
                        almoxarifado.setValue(' ');
                        currentRow.CDALMOXARIFE = ' ';

                        localestoque.readOnly = true;
                        localestoque.validations = null;
                        localestoque.setValue(' ');
                        currentRow.CDLOCALESTOQ = ' ';

                    }

                }.bind(this));
            }
            else {
                currentRow.ALMOXARIFADO = false;
                currentRow.LOCALESTOQUE = false;
                currentRow.NRLOTEESTOQ = false;

                widget.getField('DSALMOXARIFE').readOnly = true;
                widget.getField('DSLOCALESTOQ').readOnly = true;
                widget.getField('NRLOTEESTQ').readOnly = true;

                widget.getField('DSALMOXARIFE').validations = null;
                widget.getField('DSLOCALESTOQ').validations = null;
                widget.getField('NRLOTEESTQ').validations = null;

                this.reloadFields(widget, true, true, true);
            }
        }
    };

    this.checkAlmoxariFields = function(widget) {
        var currentRow = widget.currentRow;

        if (currentRow.CDALMOXARIFE && currentRow.LOCALESTOQUE) {
            widget.getField('DSLOCALESTOQ').readOnly = false;
            widget.getField('DSLOCALESTOQ').dataSourceFilter[2] = { "name": "CDALMOXARIFE", "operator": "=", "value": currentRow.CDALMOXARIFE };
        }
        else widget.getField('DSLOCALESTOQ').readOnly = true;

        if (arguments[1]) this.reloadFields(widget, true, true, true);
        else this.reloadFields(widget, false, true, false);
    };

    this.reloadFields = function(widget, almoxarifado, localestoque, lote) {
        var currentRow = widget.currentRow;

        if (almoxarifado) {
            currentRow.CDALMOXARIFE = (currentRow.ALMOXARIFADO) ? null : ' ';
            currentRow.DSALMOXARIFE = (currentRow.ALMOXARIFADO) ? null : ' ';

            widget.getField('DSALMOXARIFE').reload();
        }

        if (localestoque) {
            currentRow.CDLOCALESTOQ = (currentRow.LOCALESTOQUE) ? null : ' ';
            currentRow.DSLOCALESTOQ = (currentRow.LOCALESTOQUE) ? null : ' ';

            widget.getField('DSLOCALESTOQ').reload();
        }

        if (lote) {
            currentRow.NRLOTEESTQ = null;
            currentRow.NRSUBLOTE = null;

            widget.getField('NRLOTEESTQ').reload();
        }
    };

    this.setDefaultValues = function(currentRow, formWidget, first) {
        var data = moment().format('DD/MM/YYYY');
        // var primeiroDia = moment(data, 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY');
        // var ultimoDia   = moment(data, 'DD/MM/YYYY').endOf('month').format('DD/MM/YYYY');

        if (!currentRow.DTPERINI || !currentRow.DTPERFIN) {
            currentRow.DTPERINI = data;
            currentRow.DTPERFIN = data;
        }
        currentRow.HEADER_DESCR = 'S';
        if (currentRow.REPORT_NAME === 'Est31300MovEstoque' ||
            currentRow.REPORT_NAME === 'Est31300MovEstoqueSintetico' ||
            currentRow.REPORT_NAME === 'Est31400MovEstoqueConsolidadoAnali' ||
            currentRow.REPORT_NAME === 'Est31400MovEstoqueConsolidadoSint' ||
            currentRow.REPORT_NAME === 'Est31300MovEstoqueSinteticoQuantidade' ||
            first) {

            currentRow.IDLANCTO = 3;
            currentRow.CUSTOS = 1;

            var campoNivel = formWidget.getField('NPTOTALIZA');
            var levels = General.getLevelByMask('GER_CDPICTPROD', 1);
            campoNivel.dataSource.data = [];
            for (var index in levels) {
                if (index < levels.length)
                    campoNivel.dataSource.data.push({
                        "name": levels[index].nivel,
                        "value": levels[index].caracteres
                    });
            }
            campoNivel.readOnly = false;
            campoNivel.setValue(campoNivel.dataSource.data[0].value);

            currentRow.CDALMOXARIFE = ' ';
            currentRow.CDLOCALESTOQ = ' ';
            currentRow.NRLOTEESTOQ = ' ';

            currentRow.ALMOXARIFADO = false;
            currentRow.LOCALESTOQUE = false;
            currentRow.LOTE = false;
        }
        if (first) {
            this.getFilialLogada().then(function(success) {
                currentRow.CDFILIAL = success.dataset.filial[0].CDFILIAL;
                currentRow.NMFILIAL = success.dataset.filial[0].NMFILIAL;
                currentRow.DTPERINI = moment().format('DD/MM/YYYY');
                currentRow.DTPERFIN = moment().format('DD/MM/YYYY');
                var widget = templateManager.container.getActiveWidget();
                widget.getField('DSALMOXARIFE').dataSourceFilter.forEach(function(fil) {
                    if (fil.name == "CDFILIAL") {
                        fil.value = currentRow.CDFILIAL;
                    }
                });
                widget.getField('DSLOCALESTOQ').dataSourceFilter.forEach(function(fil) {
                    if (fil.name == "CDFILIAL") {
                        fil.value = currentRow.CDFILIAL;
                    }
                });
                widget.getField('DSALMOXARIFE').reload();
                widget.getField('DSLOCALESTOQ').reload();
                ProductField.updateProductFilters(widget);
            }.bind(this));
        }

    };

    this.getFilialLogada = function() {
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
                }
		    ];
        return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };

    this.setMinMaxDate = function(widget, MaxOrMin) {
        if (MaxOrMin === 'MAX') {
            var maxDate = widget.getField('DTPERFIN').value();
            var fieldInicial = widget.getField('DTPERINI');
            fieldInicial.maxDate = maxDate;
        }
        else {
            var minDate = widget.getField('DTPERINI').value();
            var fieldFinal = widget.getField('DTPERFIN');
            fieldFinal.minDate = minDate;
        }
    };

    this.validateReportPDF = function(widget) {
        widget.currentRow.__FORMAT = "pdf";
        this.validateReport(widget);
    };

    this.validateReportXLSX = function(widget) {
        widget.currentRow.__FORMAT = "xlsx";
        this.validateReport(widget);
    };

    this.validateReport = function(widget) {
        var currentRow = widget.currentRow;
        var compproduto = (currentRow.CDPRODFIN) ? currentRow.CDPRODFIN.replace(/[\.\-]/g, '') : null;

        if (widget.isValid()) {
            if (General.comparaPratoProduto(currentRow.CDPRODINI, compproduto, getLocalVar('GER_CDPICTPROD'))) {
                Est31300_MovimentacaodeEstoque_Service.requestReport(currentRow).then(function(birtURL) {
                    window.open(birtURL.dataset.URL[0]);
                });
            }
            else {
                ScreenService.showMessage("O Produto Final não pode ser maior que o Produto Inicial.");
            }
        }
    };

    this.fieldOnChangeRelatorio = function(widget) {

        //datasource removido do Json, relatorio desativado pois movimentacao customizavel o substituiu. Caso volte usar este relatorio deve ser feita manutenção nas tabelas de totalizacao.
        /*
        {
            "name": "Movimentação de Estoque Consolidado - Sintético (por Filial)",
            "value": "EST31300SINTCONS"
        }
        */

        //default fields bfore change
        widget.getField('NMGRUPPROD').isVisible = false;
        widget.getField('DSALMOXARIFE').setValue(null);
        widget.getField('DSLOCALESTOQ').setValue(null);

        if (widget.currentRow.REPORT_NAME === 'Est31300MovEstoqueApInventario' ||
            widget.currentRow.REPORT_NAME === 'EST31308Movdiaria') {
            widget.getField('DSALMOXARIFE').readOnly = true;
            widget.getField('DSALMOXARIFE').validations = {};
            widget.currentRow.DSALMOXARIFE = '';

            widget.getField('DSLOCALESTOQ').readOnly = true;
            widget.getField('DSLOCALESTOQ').validations = {};
            widget.currentRow.DSLOCALESTOQ = '';

            widget.getField('NRLOTEESTQ').readOnly = true;
            widget.getField('NRLOTEESTQ').validations = {};
            widget.currentRow.NRLOTEESTQ = '';

            widget.getField('IDLANCTO').readOnly = true;
            widget.currentRow.IDLANCTO = ' ';
            //widget.getField('IDLANCTO').dataSource.data.push({"name": " ", "value": " "});
            widget.getField('CUSTOS').readOnly = true;
            //widget.getField('CUSTOS').dataSource.data.push({"name": " ", "value": " "});
            widget.currentRow.CUSTOS = ' ';
            widget.getField('NPTOTALIZA').readOnly = true;
            //widget.getField('NPTOTALIZA').dataSource.data.push({"name": " ", "value": " "});
            widget.currentRow.NPTOTALIZA = ' ';
            widget.getField('NPTOTALIZA').validations = { "required": false };

            widget.getField('NMGRUPPROD').isVisible = true;

            changeSelectFieldBehavior('autocomplete', widget);
            changeDateVisibility('dia', widget);
        }

        else if (widget.currentRow.REPORT_NAME === 'Est31300MovEstoque' ||
            widget.currentRow.REPORT_NAME === 'Est31300MovEstoqueSintetico') {
            if (widget.currentRow.CDFILIAL) {
                this.checkUnidadeFields(widget);
            }
            widget.getField('IDLANCTO').readOnly = false;
            //widget.getField('IDLANCTO').dataSource.data.pop();
            widget.getField('CUSTOS').readOnly = false;
            //widget.getField('CUSTOS').dataSource.data.pop();
            widget.getField('NPTOTALIZA').readOnly = false;
            widget.getField('NPTOTALIZA').validations = { "required": true };
            widget.getField('NPTOTALIZA').dataSource = { "data": [{ "name": "", "value": "" }] };

            changeSelectFieldBehavior('autocomplete', widget);
            changeDateVisibility('dia', widget);
        }

        else if (widget.currentRow.REPORT_NAME === 'Est31400MovEstoqueConsolidadoAnali' ||
            widget.currentRow.REPORT_NAME === 'Est31400MovEstoqueConsolidadoSint') {
            if (widget.currentRow.CDFILIAL) {
                this.checkUnidadeFields(widget);
            }
            widget.getField('DSALMOXARIFE').readOnly = true;
            widget.getField('DSALMOXARIFE').validations = {};
            widget.currentRow.DSALMOXARIFE = ' ';

            widget.getField('DSLOCALESTOQ').readOnly = true;
            widget.getField('DSLOCALESTOQ').validations = {};
            widget.currentRow.DSLOCALESTOQ = ' ';

            widget.getField('NRLOTEESTQ').readOnly = true;
            widget.getField('NRLOTEESTQ').validations = {};
            widget.currentRow.NRLOTEESTQ = ' ';

            widget.getField('NPTOTALIZA').readOnly = false;
            widget.getField('NPTOTALIZA').validations = { "required": true };
            widget.getField('NPTOTALIZA').dataSource = { "data": [{ "name": "", "value": "" }] };

            changeSelectFieldBehavior('autocomplete', widget);
            changeDateVisibility('dia', widget);
        }

        else if (widget.currentRow.REPORT_NAME === 'Est31300MovEstoqueSinteticoQuantidade') {
            if (widget.currentRow.CDFILIAL) {
                this.checkUnidadeFields(widget);
            }
            widget.getField('IDLANCTO').readOnly = false;
            widget.getField('CUSTOS').readOnly = false;

            widget.getField('DSALMOXARIFE').readOnly = true;
            widget.getField('DSALMOXARIFE').validations = {};
            widget.currentRow.DSALMOXARIFE = ' ';

            widget.getField('DSLOCALESTOQ').readOnly = true;
            widget.getField('DSLOCALESTOQ').validations = {};
            widget.currentRow.DSLOCALESTOQ = ' ';

            widget.getField('NRLOTEESTQ').readOnly = true;
            widget.getField('NRLOTEESTQ').validations = {};
            widget.currentRow.NRLOTEESTQ = ' ';

            widget.getField('NPTOTALIZA').readOnly = false;
            widget.getField('NPTOTALIZA').validations = { "required": true };
            widget.getField('NPTOTALIZA').dataSource = { "data": [{ "name": "", "value": "" }] };

            changeSelectFieldBehavior('autocomplete', widget);
            changeDateVisibility('dia', widget);
        }

        // else if (widget.currentRow.REPORT_NAME === 'EST31300SINTCONS') {
        //     if (widget.currentRow.CDFILIAL) {
        //         this.checkUnidadeFields(widget);
        //     }
        //     widget.getField('DSALMOXARIFE').readOnly = true;
        //     widget.getField('DSALMOXARIFE').validations = {};
        //     widget.currentRow.DSALMOXARIFE = ' ';

        //     widget.getField('DSLOCALESTOQ').readOnly = true;
        //     widget.getField('DSLOCALESTOQ').validations = {};
        //     widget.currentRow.DSLOCALESTOQ = ' ';

        //     widget.getField('NRLOTEESTQ').readOnly = true;
        //     widget.getField('NRLOTEESTQ').validations = {};
        //     widget.currentRow.NRLOTEESTQ = ' ';

        //     widget.getField('NPTOTALIZA').readOnly = true;
        //     widget.getField('NPTOTALIZA').validations = { "required": false };
        //     widget.currentRow.NPTOTALIZA = ' ';

        //     widget.getField('DTPERINI').readOnly = true;
        //     widget.getField('DTPERFIN').readOnly = true;

        //     widget.getField('IDLANCTO').readOnly = true;
        //     widget.currentRow.IDLANCTO = ' ';
        //     widget.getField('CUSTOS').readOnly = true;

        //     changeSelectFieldBehavior('multiple', widget);
        //     changeDateVisibility('mes', widget);

        //     //Criar função para buscar parametrização e preencher as variaveis readonly; Ou nao
        // }

        //manipulação do field header
        if (widget.currentRow.REPORT_NAME != 'Est31300MovEstoqueApInventario') {
            widget.getField('HEADER_DESCR').readOnly = true;
            widget.getField('HEADER_DESCR').setValue('S');
            widget.currentRow.HEADER_DESCR = 'S';
        }
        else {
            widget.getField('HEADER_DESCR').readOnly = false;
        }
        this.setDefaultValues(widget.currentRow, widget, false);
        templateManager.updateTemplate();
        widget.reload();
    };

    var changeSelectFieldBehavior = function(type, widget) {
        if (type == 'autocomplete') {
            if (widget.getField('NMFILIAL').isVisible == false) {
                widget.getField('NMFILIAL').isVisible = true;
                widget.getField('NMFILIALMULTIPLE').isVisible = false;
                widget.getField('NMFILIALMULTIPLE').setValue(null);
                widget.getField('NMFILIAL').setValue(null);
                widget.currentRow.CDFILIAL = null;
            }
        }
        else {
            if (widget.getField('NMFILIALMULTIPLE').isVisible == false) {
                widget.getField('NMFILIALMULTIPLE').isVisible = true;
                widget.getField('NMFILIAL').isVisible = false;
                widget.getField('NMFILIALMULTIPLE').setValue(null);
                widget.getField('NMFILIAL').setValue(null);
                widget.currentRow.CDFILIAL = null;
            }
        }
    };

    var changeDateVisibility = function(type, widget) {
        if (type != 'mes') {
            if (widget.getField('DTPERINI').isVisible == false) {
                widget.getField('DTPERINI').isVisible = true;
                widget.getField('DTPERFIN').isVisible = true;
                widget.getField('DTPESQUISA').isVisible = false;
                widget.getField('DTPESQUISA').setValue(null);
                widget.getField('DTPERINI').setValue(null);
                widget.getField('DTPERFIN').isVisible = true;
            }
        }
        else {
            if (widget.getField('DTPESQUISA').isVisible == false) {
                widget.getField('DTPERINI').isVisible = false;
                widget.getField('DTPERFIN').isVisible = false;
                widget.getField('DTPESQUISA').isVisible = true;
                widget.getField('DTPESQUISA').setValue(null);
                widget.getField('DTPERINI').setValue(null);
                widget.getField('DTPERFIN').setValue(null);
            }
        }
    };

    this.changeToSelectMultiple = function(fieldSelectArgs, selected = false) {
        var selectField = fieldSelectArgs.owner.name == 'confirmarSelect' ? fieldSelectArgs.owner.widget.selectField : fieldSelectArgs.owner.field;
        var formWidget = selectField.getParent();
        var selectFieldWidget = selectField.selectWidget;

        if (fieldSelectArgs.owner.name != 'confirmarSelect')
            selectFieldWidget.unSelectAll();

        if (!selected) {
            if (formWidget.currentRow.REPORT_NAME != 'EST31300SINTCONS') {
                selectFieldWidget.showCheckbox = false;
                if (!!selectFieldWidget.getAction('confirmarSelect'))
                    selectFieldWidget.getAction('confirmarSelect').isVisible = false;

                eventEngine.unbindEvent(selectFieldWidget, 'WidgetAfterMoveRow', 0);
                eventEngine.bindEvent(selectFieldWidget, 'WidgetAfterMoveRow', 'args.owner.setSelected(args);');
            }
            else {
                if (!selectFieldWidget.getAction('confirmarSelect')) {
                    selectFieldWidget.showCheckbox = true;

                    var actionConfirmarSelectMultiple = {
                        name: 'confirmarSelect',
                        label: 'Confirmar',
                        showAsAction: 'never_list',
                        isVisible: true,
                        showOnList: true,
                        events: [{
                            name: 'ActionEvent',
                            code: 'args.owner.widget.setSelected(args.owner.widget.dataSource.getCheckedRows(), args.owner.widget.selectField); args.owner.widget.afterClosePopup(args.owner.widget.selectField);',
                        }]
                    };
                    actionConfirmarSelectMultiple = metaDataFactory.actionFactory(actionConfirmarSelectMultiple);
                    actionConfirmarSelectMultiple.widget = selectFieldWidget;
                    selectFieldWidget.actions.push(actionConfirmarSelectMultiple);

                    eventEngine.unbindEvent(selectFieldWidget, 'WidgetAfterMoveRow', 0);
                    eventEngine.bindEvent(selectFieldWidget, 'WidgetAfterMoveRow', 'args.owner.toggle(args.owner.currentRow);');

                    selectFieldWidget.getAction('confirmarSelect').isVisible = true;
                }
                else {
                    eventEngine.unbindEvent(selectFieldWidget, 'WidgetAfterMoveRow', 0);
                    eventEngine.bindEvent(selectFieldWidget, 'WidgetAfterMoveRow', 'args.owner.toggle(args.owner.currentRow);');
                }
            }
        }
        else {
            var selectedRows = selectFieldWidget.getCheckedRows();
            var multiItens = selectedRows.length !== 1;

            if (!multiItens) {
                args.owner = selectFieldWidget;
                selectFieldWidget.setSelected(args);
                return args;
            }

            ScreenService.closePopup();
        }
        templateManager.updateTemplate();
    };

    this.onChangeData = function(args) {
        if (args.owner.field.value()) {
            var widget = args.owner.field.widget;
            var mes = args.owner.field.value().split("/")[0];
            var ano = args.owner.field.value().split("/")[1];
            var firstDay = new Date(ano, mes - 1, 1).getDateBr();
            var lastDay = new Date(ano, mes, 0).getDateBr();
            var fieldDTINI = widget.getField('DTPERINI');
            var fieldDTFIN = widget.getField('DTPERFIN');
            fieldDTINI.setValue(firstDay);
            fieldDTFIN.setValue(lastDay);
        }
    };

    this.cleanFieldsOnChange = function(field) {
        let widget = field.widget;
        let fieldProdIni = widget.getField('NMPRODINI');
        let fieldProdFim = widget.getField('NMPRODFIN');
        let fieldGrupProd = widget.getField('NMGRUPPROD');

        switch (field.name) {
            case 'NMPRODFIN':
            case 'NMPRODINI':
                fieldProdIni.validations = { "required": true };
                fieldProdFim.validations = { "required": true };
                delete fieldGrupProd.validations;
                widget.currentRow.NMGRUPPROD = '';
                widget.currentRow.CDGRUPPROD = '';
                break;
            case 'NMGRUPPROD':
                widget.currentRow.NMPRODINI = '';
                widget.currentRow.NMPRODFIN = '';
                widget.currentRow.CDPRODINI = '';
                widget.currentRow.CDPRODFIN = '';
                delete fieldProdIni.validations;
                delete fieldProdFim.validations;
                fieldGrupProd.validations = { "required": true };
        }

    };

    this.saveParamsRelat = function(args) {
        let widget = args.owner.widget;
        let row = widget.currentRow;
        General.callRestEngine("est_relatorios#/saveParamsMoviest", "Row", row).then((result) => {

            ScreenService.closePopup();
            widget.container.getWidget('est31300').edit();
            widget.container.getWidget('est31300').activate();
        });
    };

    this.openPopupParams = function(args) {
        let widgetPopup = templateManager.container.getWidget('popupParametrizacao');
        widgetPopup.reload().then(loaded => {
            if (loaded) {
                widgetPopup.currentRow = loaded.dataset.getParamsMoviest[0];
                widgetPopup.fields.forEach(field => field.reload());
            }

            ScreenService.openPopup(widgetPopup).then(done => {
                widgetPopup.edit();
                templateManager.updateTemplate();
            });
        });

    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Est31300_MovimentacaodeEstoque_Controller', Est31300_MovimentacaodeEstoque_Controller);
});
